hdu 1394 Minimum Inversion Number 线段树 点更新

// hdu 1394 Minimum Inversion Number 线段树 点更新
//
// 典型线段树的单点更新
//
// 对于求逆序数,刚开始还真的是很年轻啊,裸的按照冒泡排序
// 求出最初始的逆序数,然后按照公式递推,结果就呵呵了
//
// 发现大牛都是用线段树和树状数组之类的做的,而自己又在学
// 线段树,所以就敲了线段树。
//
// 线段树的节点保存一段区间( L,R )内0,1...n一共出现了多少个。
// 因为每个数是0,1,2...n-1且没有重复的数字。
// 当插入一个数x的时候,我们查询当前状况下(x,n)(ps:本来这段区间内已经
// 有多少个数,将这个结果累加,就是最初的逆序对数。
//
// 之后,就是将开头的数字移动到末尾的情况了
// 首先我们来看一下序列abcde...(每个数都是1到n)到bcde...a逆序数的变化情况
// 设a的值为x,这个序列小于a的值是x-1,大于a的值是n-x。那么
// 将a移动到序列末尾,则小于a的数都变成顺序,大于a的数变成了
// 逆序,那么这个新的逆序数就是 原来的逆序数 + n - a[i] - (a[i] - 1);

// 这题想明白了还是很简单的,继续练,加油

#include <algorithm>
#include <bitset>
#include <cassert>
#include <cctype>
#include <cfloat>
#include <climits>
#include <cmath>
#include <complex>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <deque>
#include <functional>
#include <iostream>
#include <list>
#include <map>
#include <numeric>
#include <queue>
#include <set>
#include <stack>
#include <vector>
#define ceil(a,b) (((a)+(b)-1)/(b))
#define endl '\n'
#define gcd __gcd
#define highBit(x) (1ULL<<(63-__builtin_clzll(x)))
#define popCount __builtin_popcountll
typedef long long ll;
using namespace std;
const int MOD = 1000000007;
const long double PI = acos(-1.L);

template<class T> inline T lcm(const T& a, const T& b) { return a/gcd(a, b)*b; }
template<class T> inline T lowBit(const T& x) { return x&-x; }
template<class T> inline T maximize(T& a, const T& b) { return a=a<b?b:a; }
template<class T> inline T minimize(T& a, const T& b) { return a=a<b?a:b; }

const int maxn = 5008 ;

int tree[maxn<<2];

int n;

int a[maxn];

void build(int ro,int L,int R){
	tree[ro] = 0;
	if ( L == R )
		return ;

	int M = L + ( R - L ) / 2;
	build(ro * 2,L,M);
	build(ro * 2 + 1,M+1,R);

}
int p,v;
int ql,qr;
int query(int ro,int L,int R){
	if (ql <= L && R <= qr){
		return tree[ro];
	}
	int M = L + ( R - L ) / 2;
	int ans = 0;
	if (ql <= M)	ans += query(ro * 2,L,M);
	if (M < qr)		ans += query(ro * 2 + 1,M+1,R);
	return ans;
}

void push_up(int ro){
	tree[ro] = tree[ro * 2] + tree[ro * 2 + 1];
}

void update(int ro,int L,int R){
	if ( L == R ){
		tree[ro]++;
		return ;
	}
	int M = L + ( R - L ) / 2;
	if (p<=M)	update(ro * 2,L,M);
	else	update(ro * 2 + 1,M+1,R);
	push_up(ro);
}

void init(){
	build(1,1,n);
	int sum = 0;
	for (int i=1;i<=n;i++){
		scanf("%d",&a[i]);
		p = ++a[i];
		ql = p;
		qr = n;
		sum += query(1,1,n);
		update(1,1,n);
	}

	int res = sum;
	for (int i=1;i<=n;i++){
		sum += n - a[i] - (a[i] - 1);
		res = min(res,sum);
	}

	printf("%d\n",res);
}

int main() {
	//freopen("G:\\Code\\1.txt","r",stdin);
	while(scanf("%d",&n)!=EOF){
		init();

	}
	return 0;
}

时间: 2024-10-11 20:18:14

hdu 1394 Minimum Inversion Number 线段树 点更新的相关文章

HDU 1394 Minimum Inversion Number.(线段树)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1394 ~~~~ 早起一发线段树,开心又快乐.这题暴力也能水过,同时线段树的效率也就体现的尤为明显了,看了大牛的博客,说是还可以用树状数组,点树和合并序列写,现在还不懂,留着以后在写吧. ~~~~ 大致题意:给定一个数字序列,同时由此可以得到n个序列, 要求从n个序列中找到逆序数最小的序列,输出最小逆序数. 首先介绍下逆序数的概念: 在一个排列中,如果一对数的前后位置与大小顺序相反,即前面的数大于后面

HDU 1394 Minimum Inversion Number (线段树,单点更新)

C - Minimum Inversion Number Crawling in process... Crawling failed Time Limit:1000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u Submit Status Practice HDU 1394 Appoint description: System Crawler (2015-08-17) Description The inversio

Hdu 1394 Minimum Inversion Number(线段树或树状数组)

Minimum Inversion Number Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 11981    Accepted Submission(s): 7321 Problem Description The inversion number of a given number sequence a1, a2, ..., a

HDU 1394 Minimum Inversion Number (线段树,暴力)

Description The inversion number of a given number sequence a1, a2, ..., an is the number of pairs (ai, aj) that satisfy i < j and ai > aj. For a given sequence of numbers a1, a2, ..., an, if we move the first m >= 0 numbers to the end of the seq

hdu - 1394 Minimum Inversion Number(线段树水题)

http://acm.hdu.edu.cn/showproblem.php?pid=1394 很基础的线段树. 先查询在更新,如果后面的数比前面的数小肯定会查询到前面已经更新过的值,这时候返回的sum就是当前数的逆序数. 这样查询完之后得到初始数列的逆序数,要求得所有序列的最小逆序数,还需要循环一次. 设初始序列abcde中逆序数为k,小于a的个数是t-1那么大于a的个数就是n-t,当把a左移一位,原来比a大的都变成了a的逆序对,即逆序数增加了n-t,但是原来比a小的数都变成了顺序, 因此逆序数

hdu 1394 Minimum Inversion Number 线段树

Problem Description The inversion number of a given number sequence a1, a2, ..., an is the number of pairs (ai, aj) that satisfy i < j and ai > aj. For a given sequence of numbers a1, a2, ..., an, if we move the first m >= 0 numbers to the end of

hdu 1394 Minimum Inversion Number (裸树状数组 求逆序数)

题目链接 题意: 给一个n个数的序列a1, a2, ..., an ,这些数的范围是0-n-1, 可以把前面m个数移动到后面去,形成新序列:a1, a2, ..., an-1, an (where m = 0 - the initial seqence)a2, a3, ..., an, a1 (where m = 1)a3, a4, ..., an, a1, a2 (where m = 2)...an, a1, a2, ..., an-1 (where m = n-1)求这些序列中,逆序数最少的

Minimum Inversion Number(线段树单点更新+逆序数)

Minimum Inversion Number(线段树单点更新+逆序数) Time Limit:1000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u Submit Status Description The inversion number of a given number sequence a1, a2, ..., an is the number of pairs (ai, aj) that satisfy

hdu1394 Minimum Inversion Number(线段树单点更新||暴力)

题目链接: huangjing 这个题目暴力和线段树都可以过,但是都需要掌握一个规律.. 当队首元素移到队尾后,可定会减少a[i]个逆序对,然后增加n-1-a[i]个逆序对. 你看比如1移到队尾,那么1>0这个逆序对就会减少,2>1,3>1,4>1这些逆序对就会增加.. 所以发现这个规律就好做了.. 暴力做法就是直接那样模拟.. 线段树做法是首先建立一颗空树,然后插入之前询问这颗树中在[插入元素,n]之间的树,求出来的就是逆序对的个数.然后将其更新进去即可.. 题目: 寻人启事:2